import moment = require("moment");
import { MEMBERLEVEL, MEMBERTYPE, STATE, USERREGISTERSTATE } from "../config/enum";
import { TABLEENUM } from "../data/models/model";
import { find, findCount, findOnce } from "../data/select";
import { createOrder } from "./member/order";

/**
 * 初始化任务
 */
export function initSystemTask() {
    /**孵化器月度任务 */
    createUserOrder();
    setInterval(async function () {
        await createUserOrder();
    }, 24 * 3600 * 1000);

    console.log(`systemTask init success`);
}

export async function createUserOrder() {
    const NowMs = new Date().valueOf();
    /**到期时间距离今天小于90天 */
    let selectParam:any = {
        "$and":[
            {lifespanEndTime:{"$lt":NowMs + (30 * 24 * 3600 * 1000)}}
        ],
        isAdmin:STATE.否,
        userRegisterState:USERREGISTERSTATE.通过
    }
    let files = ["userId", "lifespanEndTime", "loginId", "phone", "unitName", "memberLevel", "memberType", "unitMemberType", "individualMemberType"];
    let count = await findCount(TABLEENUM.用户表, selectParam);
    if (count) {
        let userList = await find(TABLEENUM.用户表, selectParam, files );
        let addCount = 0;
        for (let i= 0; i < userList.length; i++) {
            let { userId, lifespanEndTime, loginId, phone, unitName, memberLevel, memberType, unitMemberType, individualMemberType} = userList[i];
            let itemInfo = await findOnce(TABLEENUM.订单表, {userId, orderCycleStart:{"$gte":lifespanEndTime}}, "orderCycleStart");
            if (!itemInfo || !itemInfo.orderCycleStart) {
                /**创建一条新的订单 */
                let subType = memberType == MEMBERTYPE.个人会员 ? individualMemberType : unitMemberType;
                await createOrder(userId, loginId, phone, unitName, lifespanEndTime, memberLevel, memberType, subType, false);
                addCount += 1;
            }
        }
        console.log(`已创建${addCount}条订单`);
    }
}
